import pandas as pd
import numpy as np

df = pd.read_csv('C:/Users/hp/Desktop/ds.csv',encoding='utf-8')


from sklearn.metrics import mean_squared_error
from sklearn.metrics import r2_score
from sklearn.model_selection import train_test_split
X=df.iloc[:,1:285].values
y=df.iloc[:,0:1].values

from sklearn.preprocessing import StandardScaler
sc_x = StandardScaler()
sc_y = StandardScaler()
X_std = sc_x.fit_transform(X)
y_std = sc_y.fit_transform(y).flatten()#转换为一维数组#[:,np.newaxis]增加数组维度

X_train,X_test,y_train,y_test=train_test_split(X_std,y_std,
                                               test_size=0.2,
                                               random_state=30)
                                              
from sklearn.ensemble import RandomForestRegressor
'''for i in range(1,10,1):
    forest=RandomForestRegressor(n_estimators=28,
                             min_samples_leaf=1,
                             max_depth=2,
                             criterion='mse',
                             random_state=1,
                             n_jobs=-1)
    forest.fit(X_train,y_train)
    y_train_pred=forest.predict(X_train)
    y_test_pred=forest.predict(X_test)
    print('r2 train:%.3f,test:%.3f'%(r2_score(y_train,y_train_pred),r2_score(y_test,y_test_pred)))
   
'''

forest=RandomForestRegressor(n_estimators=28,
                             min_samples_leaf=1,
                             max_depth=2,
                             criterion='mse',
                             random_state=1,
                             n_jobs=-1)
forest.fit(X_train,y_train)
y_train_pred=forest.predict(X_train)
y_test_pred=forest.predict(X_test)

def mean_relative_error(y_true,y_pred):
    relative_error = np.average(np.abs(y_pred-y_true)/y_true,axis=0)
    return relative_error

origin_y_train = sc_y.inverse_transform(y_train) # 逆标准化
origin_y_train_pred = sc_y.inverse_transform(y_train_pred)
origin_y_test = sc_y.inverse_transform(y_test) # 逆标准化
origin_y_test_pred = sc_y.inverse_transform(y_test_pred)

print('RMSE train:%3f,test:%3f'%(mean_squared_error(origin_y_train,origin_y_train_pred,squared=False),
                               mean_squared_error(origin_y_test,origin_y_test_pred,squared=False)))
print('r2 train:%.3f,test:%.3f'%(r2_score(y_train,y_train_pred),r2_score(y_test,y_test_pred)))



print('RE train:%3f,test:%3f'%(mean_relative_error(origin_y_train,origin_y_train_pred),
                               mean_relative_error(origin_y_test,origin_y_test_pred)))

import matplotlib.pyplot as plt

plt.scatter(origin_y_test,
            origin_y_test_pred,
            c='navajowhite',
            #edgecolor='white',
            marker ='o',
            s=30,
            alpha=0.8
            )

from sklearn import linear_model
reg=linear_model.LinearRegression()
x=np.array(origin_y_test).reshape(-1,1)
reg.fit(x,origin_y_test_pred)
y_pred=reg.predict(x)
plt.plot(x,y_pred,color='navajowhite',alpha=0.8,linewidth=0.8)
#plt.xlabel('Reference SPAD')
#plt.ylabel('Predicted SPAD')
plt.xticks(fontproperties = 'Times New Roman', size = 22)
plt.yticks(fontproperties = 'Times New Roman', size = 22)
plt.ylim([0,70])
plt.xlim([0,70])
plt.tight_layout()
plt.show()
'''
y_test= sc_y.inverse_transform(y_test)
y_test_pred= sc_y.inverse_transform(y_test_pred)

plt.plot(range(len(y_test)),y_test,color='b',alpha=0.8,label='Measured value')
plt.plot(range(len(y_test)),y_test_pred,color='r',alpha=0.8,label='Predicted value')
plt.xticks(fontproperties = 'Times New Roman', size = 20)
plt.yticks(fontproperties = 'Times New Roman', size = 20)
plt.ylim([10,70])
plt.xlim([0,135])
font1 = {'family' : 'Times New Roman','weight' : 'normal','size'   : 20}
plt.legend(loc='lower left',prop=font1)
plt.show()
'''
